
############################################################
#                                                          #
#                 Load Model                               #
#                                                          #
############################################################
#This script is called from UK to set model data:
#"/esarchive/exp/wrf-hermes-cmaq/b075_full_year/cat/daily_mean/pm10/"

# fitxers pel pm10 del tipus pm10_2021123100.nc, pm2p5_2021121500.nc
# sconcno2_2022021200.nc

n_lat                <- 278        #latitude
n_lon                <- 298        #longitude
model                <- array(dim=c(n_lat,n_lon,0)) #we prepare an array to put the date in

# We download the model by days
for (date in dates) {
  
  #date<-"20210101"
  conc_path_day  <- paste0(date, "00")
  file           <- paste0(name_pollutant, "_", conc_path_day, ".nc", sep="")
  file_path      <- paste0(model_path, file)
  
  if (file.exists(file_path)) {
    netcdf_model      <- RNetCDF::open.nc(file_path) #Dintre de la llibreria executem la funció open i aplica-ho al fitxer obs
    
    #Extraiem les dades del model
    model_day      <- RNetCDF::var.get.nc(netcdf_model, name_pollutant) #Concentracions del NO2
    
    if(data_resolution==1){
      model_day      <- model_day[,,1:24]
    }
    
    model_day      <- model_day*mod_constant #les dades del model les tens en ppm i nosaltres ho volem en microg/m3
  
    }else{
      if(data_resolution==1){
      model_day       <- array(NaN, dim=c(n_lat,n_lon,24)) #if we dont have data for a certain day its filled by NaN
      } else{
        model_day       <- array(NaN, dim=c(n_lat,n_lon)) #if we dont have data for a certain day its filled by NaN
    }
    }
  
  if(data_resolution==1){
    model            <- abind(model,model_day,along=3)
  }else{
    model            <- abind(model,model_day) #### ! no se si cal el along
    }
}

lat_model      <- RNetCDF::var.get.nc(netcdf_model, 'lat') #Latitut
lat_model      <- sapply(lat_model, as.numeric)            #era una large matrix, ara es una large numeric
lon_model      <- RNetCDF::var.get.nc(netcdf_model, 'lon') #Longitud
lon_model      <- sapply(lon_model, as.numeric)
  
  

if (save_model){
  saveRDS(object=model, file=paste0(save_result,"model_",pollutant,".rds"))
  print("Model saved")
} else {
  print("Model have not been saved")
}
